CREATE TABLE `mod_news` (
  `id_news` int(10) NOT NULL,
  `uuid_news` binary(36) NOT NULL,
  `category_news` int(10) NOT NULL DEFAULT '1',
  `date_news` date NOT NULL,
  `title_news` varchar(200) NOT NULL,
  `slug_news` varchar(250) NOT NULL,
  `subtitle_news` varchar(300) DEFAULT NULL,
  `text_news` text,
  `covertype_news` tinyint(1) NOT NULL DEFAULT '2',
  `cover_news` json,
  `legend_news` varchar(250) DEFAULT NULL,
  `view_news` bigint(100) DEFAULT '0',
  `user_news` int(10) NOT NULL DEFAULT '1',
  `time_news` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `updated_news` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
  `status_news` varchar(50) DEFAULT 'disabled'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

ALTER TABLE `mod_news`
  ADD PRIMARY KEY (`id_news`),
  ADD UNIQUE KEY `uuid_news` (`uuid_news`),
  ADD UNIQUE KEY `slug_news` (`slug_news`),
  ADD KEY `category_news` (`category_news`),
  ADD KEY `user_news` (`user_news`);

ALTER TABLE `mod_news`
  MODIFY `id_news` int(10) NOT NULL AUTO_INCREMENT;
