CREATE TABLE `mod_products` (
  `id_products` bigint(10) NOT NULL,
  `uuid_products` binary(36) NOT NULL,
  `category_products` int(10) NOT NULL,
  `title_products` varchar(200) NOT NULL,
  `slug_products` varchar(300) NOT NULL,
  `subtitle_products` varchar(300) DEFAULT NULL,
  `text_products` longtext,
  `cover_products` json,
  `view_products` bigint(100) DEFAULT '0',
  `user_products` bigint(10) DEFAULT '1',
  `time_products` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `updated_products` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
  `status_products` varchar(50) DEFAULT 'disabled'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

ALTER TABLE `mod_products`
  ADD PRIMARY KEY (`id_products`),
  ADD UNIQUE KEY `uuid_products` (`uuid_products`),
  ADD UNIQUE KEY `slug_products` (`slug_products`),
  ADD KEY `category_products` (`category_products`),
  ADD KEY `user_products` (`user_products`);

ALTER TABLE `mod_products`
  MODIFY `id_products` int(10) NOT NULL AUTO_INCREMENT;
