<?php

if (!function_exists('varsManipuleCore')) {
    function varsConfigCore() {
        $varsConfigCore = varsConfig();

        if (!isset($varsConfigCore['URL'])) {
            if ($varsConfigCore['ENV'] == 'development') {
                $varsConfigCore['URL'] = 2;
            }
            else if ($varsConfigCore['ENV'] == 'production') {
                $varsConfigCore['URL'] = '0';
            }
        }

        if (!isset($varsConfigCore['SANDBOX'])) {
            $varsConfigCore['SANDBOX'] = false;
        }

        if (!isset($varsConfigCore['BASE_URL'])) {
            if ($varsConfigCore['ENV'] == 'development') {
                $varsConfigCore['BASE_URL'] = 'http://';
            }
            else if ($varsConfigCore['ENV'] == 'production') {
                $varsConfigCore['BASE_URL'] = 'https://';
            }
        }

        $varsConfigCore['BASE_PATH'] = $varsConfigCore['BASE_URL'].$varsConfigCore['DOMAIN'];

        $varsConfigCore['BASE_ROOT'] = __DIR__.'/../..';

        $varsConfigCore['CMSKEY'] = 'flex';

        $varsConfigCore['SECRET_KEY'] = 'uG.6GyI^X&BSDqrgO^4IIWO@<tFv"%t^8hY%G<;XX*aed/bm9X`puxDu_[+,OZD';
        $varsConfigCore['ROOT_APP'] = $varsConfigCore['BASE_ROOT'].'/app';
        $varsConfigCore['ROOT_PUBLIC'] = $varsConfigCore['BASE_ROOT'].'/public';

        $varsConfigCore['ROOT_SITE'] = $varsConfigCore['ROOT_APP'].'/site';
        $varsConfigCore['ROOT_CMS'] = $varsConfigCore['ROOT_APP'].'/painel';

        $varsConfigCore['PATH_SITE'] = $varsConfigCore['BASE_PATH'].'/app/site';
        $varsConfigCore['PATH_CMS'] = $varsConfigCore['BASE_PATH'].'/'.$varsConfigCore['CMSKEY'];
        $varsConfigCore['PATH_PUBLIC'] = $varsConfigCore['BASE_PATH'].'/public';

        $varsConfigCore['LANG'] = 'pt_BR';
        $varsConfigCore['LANG_URL'] = 'br';

        if (!isset($varsConfigCore['DATABASE_LOCAL']['host'])) {
            $varsConfigCore['DATABASE_LOCAL']['host'] = 'localhost';
        }

        if (!isset($varsConfigCore['DATABASE_LOCAL']['port'])) {
            $varsConfigCore['DATABASE_LOCAL']['port'] = '3309';
        }

        if (!isset($varsConfigCore['DATABASE_LOCAL']['username'])) {
            $varsConfigCore['DATABASE_LOCAL']['username'] = 'root';
        }

        if (!isset($varsConfigCore['DATABASE_LOCAL']['password'])) {
            $varsConfigCore['DATABASE_LOCAL']['password'] = 'root@devRemote#developer';
        }

        if (!isset($varsConfigCore['DATABASE_ONLINE']['host'])) {
            $varsConfigCore['DATABASE_ONLINE']['host'] = 'localhost';
        }

        if (!isset($varsConfigCore['DATABASE_ONLINE']['port'])) {
            $varsConfigCore['DATABASE_ONLINE']['port'] = '3306';
        }

        if (!isset($varsConfigCore['CARD_INFO_DASHBOARD'])) {
            $varsConfigCore['CARD_INFO_DASHBOARD'] = '3306';
        }

        $varsConfigCore['FRONTEND'] = 'Expand - www.expandweb.com';
        $varsConfigCore['BACKEND'] = 'Expand - www.expandweb.com';
        $varsConfigCore['AUTHOR'] = 'Expand';

        $varsConfigCore['SIGNATURE'] = 'Expand Agência de Publicidade. Criação de sites, campanhas publicitárias, SEO, marketing, midias sociais, hospedagem web e desenvolvimento.';
        $varsConfigCore['SIGNATUREMIN'] = 'Expand';
        $varsConfigCore['SIGNATUREURL'] = 'https://www.expandweb.com';

        $varsConfigCore['VERSION'] = '4.1.0 (março/2024)';
        $varsConfigCore['LABEL_SYSTEM_VERSION'] = 'ExpandFLEX 4.1.0';
        $varsConfigCore['LABEL_SYSTEM_LOGO'] = 'ExpandFLEX';
        $varsConfigCore['LABEL_SYSTEM_NAME'] = 'ExpandFLEX';
        $varsConfigCore['LABEL_SYSTEM_TITLE'] = 'ExpandFLEX | Sistema de Gerenciamento de Conteúdo para Websites';
        $varsConfigCore['LABEL_SYSTEM_AUTHOR'] = 'Expand';
        $varsConfigCore['LABEL_SYSTEM_AUTHORMIN'] = 'Expand';
        $varsConfigCore['LABEL_SYSTEM_DESCRIPTION'] = 'Sistema de Gerenciamento de Conteúdo para Websites';
        $varsConfigCore['LABEL_SYSTEM_KEYWORDS'] = 'sistema, gerenciamento, gerenciamento, conteúdo, websites, framework, php7.2, mysql, pdo, gulp, bower, composer, npm, nodejs';
        $varsConfigCore['LABEL_CALLBACK'] = '[ ExpandFLEX ]';
        $varsConfigCore['DATEFOUNDATION'] = 2005;
        $varsConfigCore['LABEL_EMAIL_NOREPLY'] = 'developer@expandweb.com';
        $varsConfigCore['LABEL_EMAIL_SUPPORT'] = 'developer@expandweb.com';
        $varsConfigCore['LABEL_NAME_SUPPORT'] = '[SUPORTE] '.$varsConfigCore['LABEL_SYSTEM_NAME'];
        $varsConfigCore['SITE_AUTHOR'] = 'https://www.expandweb.com';
        $varsConfigCore['DEVELOPER'] = 'Ângelo Marafelli - https://github.com/angelomarafelli';
        $varsConfigCore['CARD_INFO_DASHBOARD'] = '
        <p>O <b>'.$varsConfigCore['LABEL_SYSTEM_TITLE'].'</b>, é um sistema elaborado especialmente para que você gerencie todo conteúdo do seu website ou aplicativo, dinamicamente, em qualquer computador ou dispositivo móvel conectado à internet.</p>
        <p>Ficamos felizes por escolher nosso sistema e queremos que sua utilização seja a mais simplificada possível. Para contribuir com a otimização do sistema <a href="'.$varsConfigCore['PATH_CMS'].'/system/?base=system/static&operation=support" title="Enviar Feedback">envie-nos o seu feedback.</a></p>
        <p>A segurança é uma grande preocupação para nós, por isso, caso descubra alguma falha de segurança notifique-nos utilizando o formulário de contato direto com nossa equipe de suporte.</p>
        <p>Nessa versão foram implementadas diversas melhorias que farão sua utilização mais simples e a experiência mais produtiva. Utilize em diversos navegadores, inclusive pelo seu smartphone e mantenha seu site sempre bem atualizado.</p>
        <p>Agradecemos sua utilização.</p>';

        $varsConfigCore['INDEX_LOGO_WIDTH'] = '40%';
        $varsConfigCore['INDEX_COMPANY_WIDTH'] = '104px';
        $varsConfigCore['DASHBOARD_COMPANY_WIDTH'] = '80px';
        $varsConfigCore['ABOUT_LOGO_WIDTH'] = '100px';
        $varsConfigCore['ABOUT_COMPANY_WIDTH'] = '80px';
        $varsConfigCore['BG_CHART'] = 'rgba(0, 115, 183, 1)';

        return $varsConfigCore;
    }
}
